<?php
/**
* @version 1.0.0
* @package RSSearch! 1.0.0
* @copyright (C) 2011 www.rsjoomla.com
* @license GPL, http://www.gnu.org/licenses/gpl-2.0.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.plugin.plugin');

class plgRSSearchJEvents extends JPlugin
{
	public function __construct( &$subject, $config ) {
		parent::__construct( $subject, $config );
	}

	public function getResults(&$results, $search, $params) {
	    $db 		= JFactory::getDBO();
	    $fields 	= (array) $this->params->get('searchfields','');
	    $categories = (array) $this->params->get('jeventscategories','');
	    $orderby 	= $this->params->get('orderby','name');
	    $asc_desc 	= $this->params->get('asc_desc','ASC');
	    $itemId 	= $this->params->get('Itemid','');
	    $itemId 	= (empty($itemId) ? '' : '&Itemid='.$itemId);
		
		JFactory::getLanguage()->load('plg_rssearch_jevents',JPATH_ADMINISTRATOR);
		
		require_once JPATH_SITE.'/components/com_jevents/libraries/helper.php';
		require_once JPATH_ADMINISTRATOR . '/components/com_search/helpers/search.php';
		
		foreach ($fields as $field) {
			if ($field == 'jevents_events') {
				$tablecolumns	= array('summary','description','start','end');
				$where_catid	= '';
				
				if (!in_array('', $categories)) {
					JArrayHelper::toInteger($categories);
					$where_catid = ' AND '.$db->qn('e.catid').' IN ('.implode(',', $categories).') ';
				}

				$query = 'SELECT '.$db->qn('ed.evdet_id').', '.$db->qn('ed.summary').', '.$db->qn('ed.description').', '.$db->qn('e.catid').', '.$db->qn('e.uid').' FROM '.$db->qn('#__jevents_vevdetail','ed').' LEFT JOIN '.$db->qn('#__jevents_vevent','e').' ON '.$db->qn('ed.evdet_id').' = '.$db->qn('e.ev_id').' WHERE ('.$db->qn('ed.summary').' LIKE '.$db->q('%'.$search.'%').' OR '.$db->qn('ed.description').' LIKE '.$db->q('%'.$search.'%').') AND '.$db->qn('e.state').' = 1 '.$where_catid.' GROUP BY '.$db->qn('ed.evdet_id').'';
				
				if (in_array($orderby,$tablecolumns)) 
					$query .= ' ORDER BY '.$db->escape($orderby).' '.$db->escape($asc_desc);

				$db->setQuery($query);
				if ($list = $db->loadObjectList()) {
					foreach ($list as $item) {
						if ( !searchHelper::checkNoHTML($item, $search, array('summary', 'description')) ) continue;

						list($year, $month, $day) = JEVHelper::getYMD();
						$tmp		= new stdClass();
						$tmp->title = $item->summary;
						$tmp->link 	= JRoute::_('index.php?option=com_jevents&task=icalrepeat.detail&evid='.$item->evdet_id.$itemId.'&year='.$year.'&month='.$month.'&day='.$day.'&title='.JFilterOutput::stringURLSafe($item->summary).'&uid='.$item->uid);				
						$tmp->text 	= $item->description;
						$tmp->type	= JText::_('RSF_JEVENTS_XML_EVENT');
						$results[] 	= $tmp;
					}
				}
			} elseif ($field == 'jevents_categories') {
				$tablecolumns = array('name','level');
				
				if (!in_array('', $categories)) {
					JArrayHelper::toInteger($categories);
					$where_catid = ' AND '.$db->qn('id').' IN ('.implode(',', $categories).') ';
				}
				
				$query = 'SELECT '.$db->qn('id').', '.$db->qn('title').', '.$db->qn('description').' FROM '.$db->qn('#__categories').' WHERE ('.$db->qn('title').' LIKE '.$db->q('%'.$search.'%').' OR '.$db->qn('description').' LIKE '.$db->q('%'.$search.'%').') AND '.$db->qn('published').' = 1 '.$where_catid.'';
				
				if (in_array($orderby,$tablecolumns)) 
					$query .= ' ORDER BY '.$db->escape($orderby).' '.$db->escape($asc_desc);

				$db->setQuery($query);
				if ($list = $db->loadObjectList()) {
					foreach ($list as $item) {
						if ( !searchHelper::checkNoHTML($item, $search, array('title', 'description')) ) continue;

						$tmp		= new stdClass();
						$tmp->title = $item->title;
						$tmp->link 	= JRoute::_('index.php?option=com_jevents&view=cat&layout=listevents'.$itemId.'&catids='.$item->id);
						$tmp->text 	= $item->description;
						$tmp->type	= JText::_('RSF_JEVENTS_XML_CATEGORY');
						$results[] 	= $tmp;
					}
				}
			}
		}
	    return true;
	}
}